#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void split_str(char* s, char c) {
    int prev = 0;
    int curr = 0;
    char token[100];
    while (1) {
        while (s[curr] != '\0' && s[curr] != c) {
            curr++;
        }
        strncpy(token, s+prev, curr-prev);
        token[curr-prev] = '\0';
        puts(token);
        if (s[curr] == '\0') {
            break;
        }
        prev = curr + 1;
        curr = prev;
    }
}

void compress2(char* s1, char* s2) {
    s2[0] = '\0';
    char pom[10];

    int i = 0;
    while (s1[i] != '\0') {

        int cnt = 1;
        while (s1[i] == s1[i+1]) {
            cnt++;
            i++;
        }

        sprintf(pom, "%c", s1[i]);
        strcat(s2, pom);

        sprintf(pom, "%d", cnt);
        strcat(s2, pom);

        i++;
    }
}

void decompress(char* s1, char* s2) {
    int i = 0;
    int j = 0;
    while (s1[i] != '\0') {

        char c = s1[i];
        int br = s1[i+1] - '0';
        i += 2;

        int k;
        for (k = 0; k < br; k++) {
            s2[j] = c;
            j++;
        }
    }
    s2[j] = '\0';
}

void decompress2(char* s1, char* s2) {
    int i = 0;
    int j = 0;
    char pom[100];
    while (s1[i] != '\0') {

        char c = s1[i];
        int k = i+1;
        while (s1[k] != '\0' && '0' <= s1[k] && s1[k] <= '9') {
            k++;
        }
        strncpy(pom, s1+i+1, k-(i+1));
        int br;
        br = atoi(pom);
        //sscanf(pom, "%d", &br);
        i = k;

        for (k = 0; k < br; k++) {
            s2[j] = c;
            j++;
        }
    }
    s2[j] = '\0';
}

void umetni(char *str1, char*str2) {
    char res[100];
    int i = 0;
    int j = 0;
    while (str2[i] != '\0') {
        res[j] = str1[i];
        res[j+1] = str2[i];
        j += 2;
        i++;
    }
    while (str1[i] != '\0') {
        res[j] = str1[i];
        i++;
        j++;
    }
    res[j] = '\0';
    strcpy(str1, res);
}

int faktorijel(int n) {
    if (n == 0) {
        return 1;
    }
    else {
        return faktorijel(n-1) * n;
    }
}

int fib(int n) {
    if (n <= 1) {
        return 1;
    }
    return fib(n-1) + fib(n-2);
}

int main()
{
    char s1[100] = "principi programiranja AB";
    split_str(s1, ' ');

    char s2[100] = "aaabbbbcccccaaaaaaaaaa";;
    char s3[100];
    compress2(s2, s3);
    puts(s3);
    char s4[100];
    decompress2(s3, s4);
    puts(s4);

    char s5[100] = "PMF D smjer";
    char s6[100] = "ABC";
    umetni(s5, s6);
    puts(s5);

    printf("%d\n", faktorijel(5));
    printf("%d\n", fib(5));

    return 0;
}
